Unit GGraph;             { General graph unit for version 3 }
{$N+,E+}                       { Only one mode - so far VGA }
{$C FIXED PRELOAD PERMANENT} { Both Real and Protected mode }

Interface

Uses Dos, Crt, Graph;

Const VGAX : longint = 639;          { Standard coordinates }
      VGAY : longint = 479;

Var VGAOK    :boolean;         { Is the mode standard VGA ? }
    MaxX     :longint;                { Maximum coordinates }
    MaxY     :longint;
    GrDriver :integer;             { Variables for graphics }
    GrMode   :integer;
    MenuFont :word;                    { Menu font and size }
    MenuSize :word;
    GBandW   :boolean;           { forcing B&W - default no }

Procedure LoadGraphics;                { Preparing Graphics }

Procedure GraphInit;              { Graphics initialization }

Procedure GGraphInit;     { General graphics initialization }

Procedure GSetColor(Color: Word);
     { Set color or WHITE if GBandW is true (not for Black) }


Implementation

{***********************************************************}

  Procedure TRIPfont;         external;         {$L TRIP.OBJ}
  Procedure LITTfont;         external;         {$L LITT.OBJ}
  Procedure EGAVGAdriver;     external;       {$L EGAVGA.OBJ}

{***********************************************************}

Procedure DOSHalt(code :word);
  Var   VideoMode : Byte;
        Reg       : Registers;
Begin
     RestoreCrtMode;                  { normal DOS settings }
     VideoMode := Mem[Seg0040: $0049];
     if VideoMode = 7 then                      { Cursor on }
       Reg.CX := $0C0D              { monochromatic monitor }
     else
       Reg.CX := $0607;                     { color monitor }
     Reg.AX :=$0100;
     Intr($10,Reg);
     TextColor(LightGray);
     TextBackground(Black);
     ClrScr;
     Halt(code);
End;

{***********************************************************}

Procedure LoadGraphics;                { Preparing Graphics }

(*    Procedure LoadTheFontF(s:string); { Loading from file }
    Var FontF : file;
        FontP : pointer;
    begin
       { Open font file, read, register }
       Assign(FontF,s);
       {$I-} Reset(FontF, 1); {$I+}
       If IOResult<>0 then begin
          WriteLn('The font file ', s,
                  ' not found (copy the file to model directory)');
          Write('Press any key to quit'); ReadKey;
          DOSHalt(1);
       end{if};
       GetMem(FontP, FileSize(FontF));
       BlockRead(FontF, FontP^, FileSize(FontF));
       If RegisterBGIfont(FontP) < 0 then begin
          WriteLn('Error registering font: ',
                   GraphErrorMsg(GraphResult));
          Write('Press any key to quit'); ReadKey;
          DOSHalt(1);
       end{if};
    end;             *)

    Procedure LoadTheFont(p:pointer);
    begin
       if RegisterBGIfont(p) < 0 then begin
          WriteLn('Error registering font: ',
                   GraphErrorMsg(GraphResult));
          Write('Press any key'); ReadKey;
          DOSHalt(1);
       end{then};
    end;

    Procedure LoadTheDriver(p:pointer);
    begin
       if RegisterBGIdriver(p) < 0 then begin
          WriteLn('Error registering driver: ',
                   GraphErrorMsg(GraphResult));
          Write('Press any key'); ReadKey;
          DOSHalt(2);
       end{then};
    end;

  Begin { of Initialization }
     LoadTheFont(@TRIPfont);
     LoadTheFont(@LITTfont);
     LoadTheDriver(@EGAVGAdriver);
  End;

{***********************************************************}

Procedure GraphInit;              { Graphics initialization }

Var ErrCode  :integer;
    c        : char;

 Begin
   LoadGraphics;
   GrDriver := Detect;
   InitGraph(GrDriver,GrMode,'');
   ErrCode := GraphResult;
   If ErrCode <> grOk then begin
     ClrScr;
     GoToXY(3,13); Write('Graphics error:  ',
                         GraphErrorMsg(ErrCode));
     GoToXY(3,18); Write('Press any key');  c := ReadKey;
     DOSHalt(4);
   end{if};
 End;

{***********************************************************}

Procedure GGraphInit;     { General graphics initialization }
 Begin
   MaxX := GetMaxX; MaxY := GetMaxY;
   VGAX := MaxX;    VGAY := MaxY;
   VGAOK := true;
 End;

{***********************************************************}

Procedure GSetColor(Color: Word);
Begin
   If GBandW and (Color<>Black) then SetColor(White)
                                else SetColor(Color)
End;

{***********************************************************}

Begin
    GBandW := false;
End.
