Unit GPNHelp;              { PetriSim Context Help routines }
{$N+,E+}

Interface

Uses Crt, CrtES, EMouseGS, WindowsS;

{ CrtES     = Crt enhanced (some more routines) }
{ EMouseGS  = Enhanced mouse functions (graphics only) }
{ WindowsS  = windows in graphics }

 Const HWNTColI    = White;        { Help normal text color }
       HWBColI     = Cyan;          { Help background color }
       HWETColI    = Yellow;        { Help emphasized color }

 Var   HelpW    : DWindowP;                   { Help window }
       HWNTCol  : byte;            { Help normal text color }
       HWBCol   : byte;             { Help background color }
       HWETCol  : byte;             { Help emphasized color }


 Procedure OpenHelp;                     { Open Help Window }
 Procedure CloseHelp;                   { Close Help Window }
 Procedure GMainHelp;                        { In main help }
 Procedure GNoHelp;                    { No text help in V4 }
 Procedure GEditHelp;                   { In Screen editing }
 Procedure GProgHelp;       { Help on User model generation }

  Implementation

{***********************************************************}

  Procedure OpenHelp;                    { Open Help Window }
  Begin
     EPrompt;
     New(HelpW);
     HelpW^.WOpen(90,100,540,383,
                  HWNTCol,HWBCol,HWNTCol,HWETCol);
  End;

{***********************************************************}

  Procedure CloseHelp;                  { Close Help Window }
  Begin
     If HelpW^.WOK then HelpW^.WClose;
     Dispose(HelpW);
  End;

{***********************************************************}

Procedure GMainHelp;                         { In main help }
Label 1,10;
Var c : char;
    b : word;
Begin
  OpenHelp;
  If HelpW^.WOK then begin
   With HelpW^ do begin
1:                                          (* 1st page *)
     WrtE(14,1,'ACTIVATING MENU OPTIONS');
     WrtE(1,3,'Activate');
     Wrt (10,3,'one of the highlighted menu options by:');
     Wrt (1,4,'- pressing the highlighted key,');
     Wrt (1,5,'- selecting the option by arrows or mouse');
     Wrt (1,6,'  and pressing Enter or the Left button.');
     WrtE(1,8,'Quit');
     Wrt (6,8,'the menu by pressing Esc or the Right button.');
     Wrt(1,10,'  Pull-down menus may be changed directly by left');
     Wrt(1,11,'  and right arrows.');
     Wrt(1,13,'  Active menu options contain highlighted letters');
     Wrt(1,14,'  and if selected they are enclosed in rectangles.');
     WrtE(5,17,'Esc       PgDn=Left');

     Repeat
       c := CWait(b);
       If c=KNull then if b=1 then c:=KPgDn;
     Until c in [KPgDn,KEsc];
     If c=KEsc  then GoTo 10;

     WClear;                           { 2nd last page }
     WrtE(12,1,'MAIN MENU OPTIONS');
     WrtE(1,3,'Edit');
     Wrt (6,3,'= relocating objects, various displays, and');
     Wrt (6,4,'  full screen editing of the active network.');
     WrtE(1,5,'Simulate');
     Wrt (10,5,'= simulation of the active network in');
     Wrt (6,6,'  various modes, changing marking, (re)storing');
     Wrt (6,7,'  network status, simulation setup.');
     WrtE(1,8,'File');
     Wrt (6,8,'= creating nets, loading and saving files,');
     Wrt (6,9,'  "printing", and activating the DOS Shell.');
     WrtE(1,10,'Management');
     Wrt (12,10,'= listing, selecting, renaming, deleting');
     Wrt(6,11,'  nets, PetriSim options, RAM and net info.');
     WrtE(1,12,'Help');
     Wrt (6,12,'  was removed in PetriSim Version 4.');
     Wrt (6,13,'  Use HTML on-line documentation.');
     WrtE(1,14,'Quit');
     Wrt (6,14,'  terminates the PetriSim session.');
     Wrt (6,15,'  Confirmation is required if nets are in RAM.');
     WrtE(5,17,'Esc       PgUp=Right');

     Repeat
       c := CWait(b);
       If c=KNull then if b=2 then c:=KPgUp;
     Until c in [KPgUp,KEsc];
     If c=KPgUp then begin        { Previous page }
       WClear;
       GoTo 1;
     end;
10:
    end{with};
   end{WOK};
   CloseHelp;
End;

{***********************************************************}

Procedure GNoHelp;                     { No text help in V4 }
Var c : char;
    b : word;
Begin
  OpenHelp;
  If HelpW^.WOK then begin
   With HelpW^ do begin
     WrtE(2,1,'No Main Help Available in PetriSim since V.4 !');
     Wrt (2,3,'After using PetriSim for some time it became');
     Wrt (2,4,'obvious that Main text help is rarely used.');
     Wrt (2,6,'To save memory it was removed in version 4.');
     Wrt (2,8,'We suggest to open the HTML manual in your');
     Wrt (2,9,'favourite browser and to swap windows if help');
     Wrt(2,10,'is needed by ');
     WrtE(15,10,'Alt-Tab');
     Wrt(2,12,'Note that the HTML manual is typically located');
     Wrt(2,13,'in C:\PetriSim\Htmlman (make a bookmark to it).');
     WrtE(2,15,'Context help (F1) has not been changed.');
     WrtE(5,17,'Key or Button');

     c := CWait(b);
    end{with};
   end{WOK};
   CloseHelp;
End;

{***********************************************************}

Procedure GEditHelp;                    { In Screen editing }
Label 1,2,3,10;
Var c : char;
    b : word;
Begin
  OpenHelp;
  If HelpW^.WOK then begin
   With HelpW^ do begin
1:                                          (* 1st page *)
     WrtE(17,1,'FULL SCREEN EDITING');
     WrtE( 1,3,'Moving Places and Transitions:');
     Wrt ( 1,4,' Select the place or the transition by mouse, press');
     Wrt ( 1,5,' the left mouse button and drag to the new location.');
     WrtE( 1,6,'Changing parameters of Places and Transitions:');
     Wrt ( 1,7,' Select the place or the transition by mouse and press');
     Wrt ( 1,8,' the right mouse button. This activates a pull-down');
     Wrt ( 1,9,' menu with self-explaining menu options.');
     WrtE(1,10,'Creating new Places and Transitions:');
     Wrt (1,11,' Activate creating of new objects by selecting one');
     Wrt (1,12,' of the options');
        WrtE(17,12,'p'); Wrt(18,12,'lace or');
        WrtE(26,12,'t'); Wrt(27,12,'ransition. New places and');
     Wrt (1,13,' transitions are automatically given names p1,p2,...');
     Wrt (1,14,' and t1,t2,... resp. New objects are placed at the');
     Wrt (1,15,' top of the screen. Move them to their locations.');
     WrtE(5,17,'Esc       PgDn=Left');

     Repeat
       c := CWait(b);
       If c=KNull then if b=1 then c:=KPgDn;
     Until c in [KPgDn,KEsc];
     If c=KEsc  then GoTo 10;
2:
     WClear;                           { 2nd page }
     Wrt ( 1,1,' Object moved to the left side of the screen is hidden');
     Wrt ( 1,2,' (not displayed but used during simulation).');
     WrtE( 1,3,'Creating new Arcs:');
     Wrt ( 1,4,' Activate the option');
       WrtE(22,4,'a'); Wrt(23,4,'rc and select the starting');
     Wrt ( 1,5,' place or transition and the transition or the place');
     Wrt ( 1,6,' where the arc ends. The arc may be left invisible.');
     Wrt ( 1,7,' When drawing select the first and the middle corners');
     Wrt ( 1,8,' by the left button, press the right button to finish');
     Wrt ( 1,9,' the arc. The last segment ends by an arrow.');
     WrtE(1,10,'Editing Arcs:');
     WrtE(1,11,'Move corners');
         Wrt(14,11,'by mouse (select and drag by left button).');
     WrtE(1,12,'Create new corners');
         Wrt(20,12,'by selecting any point of a line');
     Wrt (1,13,' segment not close to a corner. Drag to fix location.');
     WrtE(1,14,'Delete corners');
         Wrt(16,14,'by selecting them (left button) while');
     Wrt (1,15,' holding the');
         WrtE(14,15,'Ctrl'); Wrt(19,15,'key pressed.');
     WrtE(5,17,'Esc       PgUp=Right/PgDn=Left');

     Repeat
       c := CWait(b);
       If c=KNull then if b=2 then c:=KPgUp
                  else if b=1 then c:=KPgDn;
     Until c in [KPgUp,KPgDn,KEsc];
     If c=KEsc  then GoTo 10;
     If c=KPgUp then begin        { Previous page }
       WClear;
       GoTo 1;
     end;
3:
     WClear;                           { 3rd last page }
     WrtE( 1,1,'Changing parameters of Arcs:');
     Wrt ( 1,2,' Select any arc point and activate the menu by the');
     Wrt ( 1,3,' right mouse button. Removing means that the arc');
     Wrt ( 1,4,' does not exist any more. An invisible arc exists and');
     Wrt ( 1,5,' is taken into account during simulation.');
     WrtE( 1,6,'Esc');
         Wrt(5,6,'stops the full screen editing and passes control');
     Wrt ( 1,7,' back to the Edit menu. Without mouse use F10.');
     WrtE( 1,8,'Note:');
     Wrt ( 1,9,' Searching works in this order: Arc corners,Arc points');
     Wrt (1,10,' in line segments, Transitions, Places. It means, that');
     Wrt (1,11,' a transition can not be selected at ends of incident');
     Wrt (1,12,' arcs (place can be easily selected in circle). It is');
     Wrt (1,13,' no problem to move away an arc corner temporarily and');
     Wrt (1,14,' move it back after locating properly the transition');
     Wrt (1,15,' or other adjacent arc corner.');
     WrtE(5,17,'Esc       PgUp=Right');

     Repeat
       c := CWait(b);
       If c=KNull then if b=2 then c:=KPgUp;
     Until c in [KPgUp,KEsc];
     If c=KPgUp then begin        { Previous page }
       WClear;
       GoTo 2;
     end;

10:
    end{with};
   end{WOK};
   CloseHelp;
End;

{***********************************************************}

Procedure GProgHelp;        { Help on User model generation }
Label 1,10;
Var c : char;
    b : word;
Begin
  OpenHelp;
  If HelpW^.WOK then begin
   With HelpW^ do begin
1:                                          (* 1st page *)
     WrtE(14,1,'PROGRAMMING USER MODELS');
     WrtE(2,3,'USER.PAS');
     Wrt(11,3,'is a unit made of a global part and two');
     Wrt (2,4,'include files that insert the starting and the ending');
     Wrt (2,5,'code snippets. Use the menu option');
     WrtE(37,5,'Edit USER.PAS');
     Wrt (2,6,'to change this unit. Note that there are other user');
     Wrt (2,7,'related declarations in the unit USERPART.PAS.');
     Wrt (2,8,'PetriSim contains generic procedures. Use them if you');
     Wrt (2,9,'are satisfied with standard outputs without any input');
     Wrt(2,10,'data. Bigger models need additional user declarations');
     Wrt(2,11,'and their initialization that may need some data from');
     Wrt(2,12,'keyboard or a text file.');
     Wrt(2,13,'During simulation update user data by starting and/or');
     Wrt(2,14,'ending snippets and use it to evaluate the simulation');
     Wrt(2,15,'experiment. There is no need to change the experiment');
     Wrt(2,16,'control.');
     WrtE(5,17,'Esc       PgDn=Left');

     Repeat
       c := CWait(b);
       If c=KNull then if b=1 then c:=KPgDn;
     Until c in [KPgDn,KEsc];
     If c=KEsc  then GoTo 10;

     WClear;                           { 2nd last page }
     Wrt (2,1,'After editing a code snippet, the two include files');
     Wrt (2,2,'are generated automatically, but PETRISIM.PAS must');
     Wrt (2,3,'be re-compiled in Pascal IDE !');
     Wrt (2,4,'To Edit the snippets use the Transition updating menu.');
     Wrt (2,5,'To open it click the transition by the right button.');
     Wrt (2,6,'Note that the generated procedures start by "_" and ');
     Wrt (2,7,'that PetriSim system files start by "%%". So don''t');
     Wrt (2,8,'use identifiers and file names starting like that.');
     Wrt (2,9,'Note that there are two standard procedures for');
     Wrt(2,10,'tabular and separated outputs. Use one or both.');
     Wrt(2,11,'Another two procedures implement model initialization.');
     Wrt(2,12,'Use the fast one after debugging.');
     Wrt(2,13,'Look at the procedures declared in the unit USERPART.');
     Wrt(2,14,'Among others you can generate outputs of queue places,');
     Wrt(2,15,'server transitions, and complete G/G/1 stations.');
     WrtE(5,17,'Esc       PgUp=Right');

     Repeat
       c := CWait(b);
       If c=KNull then if b=2 then c:=KPgUp;
     Until c in [KPgUp,KEsc];
     If c=KPgUp then begin        { Previous page }
       WClear;
       GoTo 1;
     end;
10:
    end{with};
   end{WOK};
   CloseHelp;
End;

{***********************************************************}

Begin
    HWNTCol  := HWNTColI;          { Help normal text color }
    HWBCol   := HWBColI;            { Help background color }
    HWETCol  := HWETCol;            { Help emphasized color }
End.

