Unit Icons;      { Various Icons for Places and Transitions }

Interface

  Uses Graph,GGraph;

  Procedure HQueueIcon(XPos,YPos,Size,Color : Integer;
                       Name : String);

  Procedure VQueueIcon(XPos,YPos,Size,Color : Integer;
                       Name : String);

  Procedure VTimedTranIcon(XPos,YPos,Size,Color : Integer;
                           Name : String);

  Procedure HTimedTranIcon(XPos,YPos,Size,Color : Integer;
                           Name : String);

  Procedure GeneratorIcon(XPos,YPos,Size,Color : Integer;
                          Name : String);

  Procedure VBranchingIcon(XPos,YPos,Size,Color : Integer;
                           Name : String);

  Procedure HBranchingIcon(XPos,YPos,Size,Color : Integer;
                           Name : String);

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

Implementation

  Procedure HQueueIcon(XPos,YPos,Size,Color : Integer;
                      Name : String);
  Var x1,x2,y1,y2 : Integer;
  Begin
     GSetColor(Color);
     SetLineStyle(SolidLn,0,NormWidth);
     x1 := XPos - Size;
     x2 := XPos + Size;
     y1 := YPos - Size;
     y2 := YPos + Size;
     Line(x1,y1,x2,y1);
     Line(x1,y2,x2,y2);
     Line(x2,y1,x2,y2);
     Dec(x2, Size div 3);
     Line(x2,y1,x2,y2);
     Dec(x2, Size div 3);
     Line(x2,y1,x2,y2);
     SetTextStyle(MenuFont,HorizDir,MenuSize);
     SetTextJustify(LeftText,CenterText);
     OutTextXY(Xpos + Size + 3,
               Ypos + Size + 3, Name);
  end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

  Procedure VQueueIcon(XPos,YPos,Size,Color : Integer;
                      Name : String);
  Var x1,x2,y1,y2 : Integer;
  Begin
     GSetColor(Color);
     SetLineStyle(SolidLn,0,NormWidth);
     x1 := XPos - Size;
     x2 := XPos + Size;
     y1 := YPos - Size;
     y2 := YPos + Size;
     Line(x1,y1,x1,y2);
     Line(x1,y2,x2,y2);
     Line(x2,y1,x2,y2);
     Dec(y2, Size div 3);
     Line(x1,y2,x2,y2);
     Dec(y2, Size div 3);
     Line(x1,y2,x2,y2);
     SetTextStyle(MenuFont,HorizDir,MenuSize);
     SetTextJustify(LeftText,CenterText);
     OutTextXY(Xpos + Size + 3,
               Ypos + Size + 3, Name);
  end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

  Procedure VTimedTranIcon(XPos,YPos,Size,Color : Integer;
                          Name : String);
  Begin
     GSetColor(Color);
     SetLineStyle(SolidLn,0,NormWidth);
     Rectangle(XPos - Size shr 2, YPos - Size shr 1,
               XPos + Size shr 2, YPos + Size shr 1);
     SetTextStyle(MenuFont,HorizDir,MenuSize);
     SetTextJustify(CenterText,TopText);
     OutTextXY(Xpos, Ypos + Size div 2 + 5, Name);
  End;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

  Procedure HTimedTranIcon(XPos,YPos,Size,Color : Integer;
                          Name : String);
  Begin
     GSetColor(Color);
     SetLineStyle(SolidLn,0,NormWidth);
     Rectangle(XPos - Size shr 1, YPos - Size shr 2,
               XPos + Size shr 1, YPos + Size shr 2);
     SetTextStyle(MenuFont,HorizDir,MenuSize);
     SetTextJustify(LeftText,CenterText);
     OutTextXY(Xpos + Size div 2 + 6, Ypos, Name);
  End;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

  Procedure GeneratorIcon(XPos,YPos,Size,Color : Integer;
                          Name : String);
  Var x1,y2 : Integer;
  Begin
     GSetColor(Color);
     SetLineStyle(SolidLn,0,NormWidth);
     x1 := XPos - Size shr 1;
     y2 := YPos + Size shr 2 + Size shr 3;
     Rectangle(x1, YPos - Size shr 2 - Size shr 3,
               XPos + Size shr 1, y2);
     x1 := XPos - Size shr 2;
     Line(x1,YPos,x1,y2);
     Line(XPos,YPos,XPos,y2);
     x1 := XPos + Size shr 3;
     Line(x1,YPos,x1,y2);
     SetTextStyle(MenuFont,HorizDir,MenuSize);
     SetTextJustify(CenterText,TopText);
     OutTextXY(Xpos, y2 + 5, Name);
  End;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

  Procedure VBranchingIcon(XPos,YPos,Size,Color : Integer;
                           Name : String);
  Var x1,x2,S : Integer;
  Begin
     GSetColor(Color);
     SetLineStyle(SolidLn,0,NormWidth);
     x1 := XPos - Size shr 2;
     x2 := XPos + Size shr 2;
     S := Size shr 1;
     Line(x1,YPos,x2,YPos - S);
     Line(x1,YPos,x2,YPos + S);
     Line(x2,YPos + S,x2,YPos - S);
     SetTextStyle(MenuFont,HorizDir,MenuSize);
     SetTextJustify(CenterText,TopText);
     OutTextXY(Xpos, YPos + S + 2, Name);
  End;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

  Procedure HBranchingIcon(XPos,YPos,Size,Color : Integer;
                           Name : String);
  Var y1,y2,S : Integer;
  Begin
     GSetColor(Color);
     SetLineStyle(SolidLn,0,NormWidth);
     y1 := YPos - Size shr 2;
     y2 := YPos + Size shr 2;
     S := Size shr 1;
     Line(XPos - S,y2,XPos,y1);
     Line(XPos,y1,XPos + S,y2);
     Line(XPos - S,y2,XPos + S,y2);
     SetTextStyle(MenuFont,HorizDir,MenuSize);
     SetTextJustify(LeftText,CenterText);
     OutTextXY(Xpos + S - 2, YPos, Name);
  End;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
End.
