Unit Labels;                { Label Nets Place Declaration }

Interface

  Uses Graph, Inhibits;

  Type  LabelsPP = ^LabelsPlace;

        LabelsPlace = Object(InhibitorPlace)
           Procedure PShow;
           { Displays the name as a label in either place
             color (if marking = 0) or marking color
             (if marking > 0). Place size is converted to
             font size, (type div 100) defines either the
             vertical or the horizontal label, (type mod 100)
             is the font - see the code. }
           Procedure PErase;
        End{LabelsPlace};

Implementation

{****************** Labels Objects Methods *****************}

  Procedure LabelsPlace.PShow;
  Begin
     Case PType div 100 of

      1 : Begin                     { 100 = Horizontal Label }
           SetTextStyle(PType mod 100, HorizDir, Size div 10);
           If Marking=0 then
             SetColor(Color)
           else
             SetColor(MColor);
           SetTextJustify(CenterText, CenterText);
           OutTextXY(XPos,YPos,Name);
          end;

      2 : Begin                       { 200 = Vertical Label }
           SetTextStyle(PType mod 100, VertDir, Size);
           If Marking=0 then
             SetColor(Color)
           else
             SetColor(MColor);
           SetTextJustify(CenterText, CenterText);
           OutTextXY(XPos,YPos,Name);
          end;

      else InhibitorPlace.PShow; { others = standard circle }
     end{case}
  end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

  Procedure LabelsPlace.PErase;
  Begin
     Case PType div 100 of

      1 : Begin                     { 100 = Horizontal Label }
           SetTextStyle(PType mod 100, HorizDir, Size div 10);
           SetColor(Black);
           SetTextJustify(CenterText, CenterText);
           OutTextXY(XPos,YPos,Name);
          end;

      2 : Begin                       { 200 = Vertical Label }
           SetTextStyle(PType mod 100, VertDir, Size);
           SetColor(Black);
           SetTextJustify(CenterText, CenterText);
           OutTextXY(XPos,YPos,Name);
          end;

      else InhibitorPlace.PErase;{ others = standard circle }
     end{case}
  end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

 End.